package jp.osdn.gokigen.gokigenassets.camera.vendor.pixpro.wrapper.command.messages.specific

import jp.osdn.gokigen.gokigenassets.camera.vendor.pixpro.wrapper.command.messages.IPixproCommandCallback
import jp.osdn.gokigen.gokigenassets.camera.vendor.pixpro.wrapper.command.messages.base.IPixproMessages
import jp.osdn.gokigen.gokigenassets.camera.vendor.pixpro.wrapper.command.messages.base.PixproCommandBase

class PixproChangeShutterSpeed(private val callback: IPixproCommandCallback, modeValue0: Int) : PixproCommandBase()
{
    private val data0: Byte = modeValue0.toByte()

    override fun getId() : Int
    {
        return (IPixproMessages.SEQ_SHUTTER_SPEED)
    }

    override fun commandBody(): ByteArray {
        return byteArrayOf(
            0x2e.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x20.toByte(), 0x1.toByte(), 0x0.toByte(), 0x0.toByte(), 0xed.toByte(), 0x3.toByte(), 0x0.toByte(), 0x0.toByte(), 0x1.toByte(), 0x0.toByte(), 0x0.toByte(), 0x80.toByte(),
            0x3.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x1.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x1.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(),
            0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(),
            0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(),
            0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x20.toByte(), 0x1.toByte(), 0x0.toByte(), 0x0.toByte(), 0x3.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(),
            0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), data0, 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x31.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(),
            0x1.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x2.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x3.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x4.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(),
            0x5.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x6.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x7.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x8.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(),
            0x9.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0a.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0b.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0c.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(),
            0x0d.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0e.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0f.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x10.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(),
            0x11.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x12.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x13.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x14.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(),
            0x15.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x16.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x17.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x18.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(),
            0x19.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x1a.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x1b.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x1c.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(),
            0x1d.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x1e.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x1f.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x20.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(),
            0x21.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x22.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x23.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x24.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(),
            0x25.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x26.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x27.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x28.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(),
            0x29.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x2a.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x2b.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x2c.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(),
            0x2d.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x2e.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x2f.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x30.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(),
            0x31.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(),
            0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(),
            0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(),
            0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(),
            0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(),
            0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(), 0x0.toByte(),

            0xff.toByte(), 0xff.toByte(), 0xff.toByte(), 0xff.toByte(),
            0x00.toByte(), 0x00.toByte(), 0x00.toByte(), 0x00.toByte()
        )
    }

    override fun responseCallback(): IPixproCommandCallback
    {
        return callback
    }
}
